/*
 * ZeroTier One - Network Virtualization Everywhere
 * Copyright (C) 2011-2016  ZeroTier, Inc.  https://www.zerotier.com/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ZT_LINUXROUTINGTABLE_HPP
#define ZT_LINUXROUTINGTABLE_HPP

#include "../node/Constants.hpp"

#ifdef __LINUX__

#include <vector>

#include "RoutingTableEntry.hpp"

namespace ZeroTier {

/**
 * Routing table interface via /proc/net/route, /proc/net/ipv6_route, and /sbin/route command
 */
class LinuxRoutingTable
{
public:
	LinuxRoutingTable();
	~LinuxRoutingTable();
	
	std::vector<RoutingTableEntry> get(bool includeLinkLocal = false,bool includeLoopback = false) const;
	RoutingTableEntry set(const InetAddress &destination,const InetAddress &gateway,const char *device,int metric);
};

} // namespace ZeroTier

#endif // __LINUX__

#endif
